/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CDBARRAPROD                                              */
/* Tabela : CDBARRAPROD                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 29/11/2004 - Ronaldo Amaral Costa                                          */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_CDBARRAPROD' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_CDBARRAPROD
GO

CREATE TRIGGER DTULTATU_CDBARRAPROD
ON CDBARRAPROD
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'CDBARRAPROD', NULL, 'CDBARRAPROD='+ CDBARRAPROD+ ';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE CDBARRAPROD
      SET DTULTATUCBAP = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(CDBARRAPROD.CDBARRAPROD,0) = ISNULL(INSERTED.CDBARRAPROD,0)) AND
            (ISNULL(CDBARRAPROD.CDPRODUTO,0)   = ISNULL(INSERTED.CDPRODUTO,0))     ;
   END;
END;
GO


UPDATE CDBARRAPROD SET DTULTATUCBAP = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUCBAP IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUCBAP' and
            type = 'D')
   ALTER TABLE CDBARRAPROD DROP CONSTRAINT DEFAULT_DTULTATUCBAP
GO

ALTER TABLE CDBARRAPROD ADD CONSTRAINT DEFAULT_DTULTATUCBAP
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUCBAP
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_CDBARRAPROD','4.11.194';
GO

