var engine = function (eventAggregator, General, ScreenService, LibUtilities, localStorageEngine, ZHPromise, LibLoginController, ZhuAclController, templateManager, ApplicationContext, requestDataSourceEngine, ZhuAclConfig) {
    
	/*---------------LOGIN---------------*/
    var validateLoginResponse = function(response, loginDefer) {
        var responseold = response;
        response = LibUtilities.changeLoginResponseToOldParams(response);
        
        response.token = responseold.LOGIN_TOKEN;
        response.redirectUrl = responseold.REDIRECT_URL;
        response.loginUserCrypto = responseold.LOGIN_USER;

        if(response && response.cdoperador) {
            startSession(response).then(function(callback) {
            
                eventAggregator.publish("loginSuccess", responseold);
                eventAggregator.publish("authSuccess", { user: response });
                loginDefer.resolve();
                
                window.localStorage.setItem("NEXTSESSION_ENCRYPTED", callback.dataset.NEXTSESSION_ENCRYPTED[0]);
             }.bind(this));
                
            /*if (!window.location.hash || window.location.hash.endsWith("product#dashboard") || !localStorageEngine.getLocalVar("CDOPERADOR") || localStorageEngine.getLocalVar("CDOPERADOR") != response.cdoperador) {
                
                eventAggregator.publish("authSuccess", { user: response });
            }
            else {
                setParameters(response);
            }*/
        }
    };
    
    this.authenticateUser = function() {
        if(typeof memoryStorage !== 'undefined') {
            localStorageEngine.getLocalVar = memoryStorage.getLocalVar;
            localStorageEngine.setLocalVar = memoryStorage.setLocalVar;
            setLocalVar = memoryStorage.setLocalVar;
            getLocalVar = memoryStorage.getLocalVar;
        }
        
        var loginDefer = ZHPromise.defer();
        localStorageEngine.setLocalVar('loginPromise', loginDefer.promise);

        LibLoginController.authenticate().then(function(response) {
            validateLoginResponse(response, loginDefer);
        }).catch(function (error) {
			if (error.data) {
				ScreenService.showMessage(error.data.error);
			} else {
				ScreenService.showMessage(JSON.stringify(error));
			}
		});
    };
    
    this.confirmLogoutLib = function(){
        ScreenService.confirmMessage("Deseja realmente sair do sistema?", "question", function(){
            LibLoginController.logout();
        }, null);
    };
	
	eventAggregator.subscribe("beforeProjectStartup", function() {
		this.authenticateUser();
	}.bind(this));
	
    var setParameters = function(user) {
        var dataAtual = moment().format("DD/MM/YYYY");
        ScreenService.buildUserData(user.nmoperador, [dataAtual, user.nmorg]);
    };
    
    var setLocalVars = function(user) {
        localStorageEngine.setLocalVar('SM_CDOPERADOR', user.cdoperador);
        localStorageEngine.setLocalVar('SM_CDFILIAL', user.cdfilialselecionada);
        localStorageEngine.setLocalVar('SM_NMFILIAL', user.nmfilialselecionada);
        localStorageEngine.setLocalVar('SM_NRORG', user.nrorg);
        localStorageEngine.setLocalVar('SM_NMORG', user.nmorg);
        localStorageEngine.setLocalVar('SM_NRORGTRAB', user.nrorgtrab);
        localStorageEngine.setLocalVar('CDOPERADOR', user.cdoperador);
        localStorageEngine.setLocalVar('NMOPERADOR', user.nmoperador);
        localStorageEngine.setLocalVar('CDFILIAL', user.cdfilialselecionada);
        localStorageEngine.setLocalVar('NMFILIAL', user.nmfilialselecionada);
        localStorageEngine.setLocalVar('NRORG', user.nrorg);
        localStorageEngine.setLocalVar('NRORGTRAB', user.nrorgtrab);
    };

    eventAggregator.subscribe('authSuccess', function(session) {
        var user = session.user;
        
        setLocalVars(user);
        setUserID(user);
        setParameters(user);
        setGeneralParameters(user.nrorg);
        menuFavoritos();
        /*var parameters = resolvePromiseWhenAnyResult(setParameters(user));

        ZHPromise.all([parameters]).then(function() {
            ScreenService.openWindow('product#dashboard');
        });*/
        var cdoperador     = user.cdoperador;
        var perfilDeAcesso = user.perfilDeAcesso;
        /* Zeedhi Access Control */
        localStorageEngine.setLocalVar("userId", cdoperador);
        localStorageEngine.setLocalVar("accessProfiles", perfilDeAcesso);
        localStorageEngine.setLocalVar("productIdLoginUrl", 911);
    }.bind(this));
    
    /* --------- CONFIGURAÇÕES DF --------- */
    function replaceMask(value, regex) {
        return typeof (value) === 'string' ? value.replace(regex, '*') : value;
    }
    
    var regularExpressions = {
        LETTERS: /((a|A))/g,
        LETTERS_AND_NUMBERS: /((a|A|9))/g
    };
    
    function setGeneralParameters(nrorg) {
        return getParamgeral().then(function (paramgeral) {
            if (paramgeral) {
                localStorageEngine.setLocalVar('CAD_CDPICTPRAT', replaceMask(paramgeral.CDPICTPRAT, regularExpressions.LETTERS));
                localStorageEngine.setLocalVar('GER_CDPICTPROD', replaceMask(paramgeral.CDPICTPROD, regularExpressions.LETTERS));
                localStorageEngine.setLocalVar('CDPICTPROD', replaceMask(paramgeral.CDPICTPROD, regularExpressions.LETTERS));
                localStorageEngine.setLocalVar('CDPICTCCTB', replaceMask(paramgeral.CDPICTCCTB, regularExpressions.LETTERS));
                localStorageEngine.setLocalVar('GER_CDPICTPRAT', replaceMask(paramgeral.CDPICTPRAT, regularExpressions.LETTERS_AND_NUMBERS));
                localStorageEngine.setLocalVar('CDPICTPRAT', replaceMask(paramgeral.CDPICTPRAT, regularExpressions.LETTERS_AND_NUMBERS));
            } else {
                ScreenService.showMessage("Parâmetros gerais não configurados", "E");
            }
        });
    }
    
    function getParamgeral() {
        return getTableByName("paramgeral").then(function(response) {
            var paramgeral = null;
            if (response.length)
                paramgeral = response[0];
            return paramgeral;
        });
    }
    
    function getTableByName(tableName, filter) {
        if (!filter) {
            filter = [];
        }
        return General.callRestEngine("product#/crud/" + tableName, "FilterData", filter).then(function (response) {
            var result = [];
            if (response.dataset[tableName])
                result = response.dataset[tableName];
            return result;
        });
    }

    var setUserID = function(user) {
        //ZhPreferences.setUserID(user.cdoperador);
        if(ApplicationContext.ZhPreferences) {
            ApplicationContext.ZhPreferences.setUserID(user.cdoperador);
        } else {
            ApplicationContext.zhCustomizationsService.registerUser(user.cdoperador);
        }
    };

    /*function resolvePromiseWhenAnyResult(promise) {
        if (promise) {
            return promise.then(function (result) {
                return result;
            })
            .catch(function (error) {
                return error;
            });
        }
    }*/
    
    eventAggregator.subscribe("onContainerOpen", function (openEvent) {
        var container = openEvent.container;
        if(container && container.label) {
            var updatedTitle = ScreenService.i18n(container.label) + " - SM";
            templateManager.updateTitle(updatedTitle);
        }
        
        menuFavoritos();
    });
    
    function startSession(user) {
        return General.callRestEngine("product#/startSession", "Row", user).then(null, callbackError);
    }
    
    function callbackError(err) {
        if (err.data && err.data.error) {
            ScreenService.showMessage(err.data.error, "E");
        } else {
            ScreenService.showMessage(JSON.stringify(err), "E");
        }
    }
    
    eventAggregator.subscribe("ZhFavoritesOnChange", (args) => {
        // Adiciona/Deleta Menu Favoritos
        // args.fullList = array<{ id, name, label }>
        // args.changed = { item: { id, name, label }, status: 'add'|'delete' }
        General.callRestEngine('product#/lib_changeFavorites', 'DataSet', [args.changed]);
    });
    
    /**
     * Teste Menu Favoritos
     */
    function menuFavoritos() {
        
        // Aguarda renderização do componente de Acesso Rápido
        setTimeout(function() {
            
            var groupId   = localStorageEngine.getLocalVar('accessProfiles');
            var projectId = localStorageEngine.getLocalVar('productIdLoginUrl');
            
            if(projectId && groupId){
                // Busca o Controle de Acesso do Operador Logado
                requestDataSourceEngine.getDataSource('zhuacl#/acl_zhu_acl_rules', ZhuAclConfig.getDefaultDataSourceFilter(groupId, projectId), 1, undefined, undefined, undefined, 120000).then(function(response){
        			var dataset = response.dataset || {};
        			
        			if(dataset){
        			    
        			    requestDataSourceEngine.getDataSource('product#/lib_findFavorites', [], 1, undefined, undefined, undefined, 120000).then(function(result) {
                           
                            var favorites = result.dataset.favorites;
                            
                            favorites = favorites[0].map(item => {
                              return {
                                id: item.ID,
                                name: item.NAME,
                                label: item.LABEL
                              };
                            });
            			    
            			    if(favorites){
                			    
                			    // Verifica Controle de Acesso do Menu Favoritos
                			    // verificaAcessoFavoritos(dataset, favorites).then(function(favorites){
                                    
                                    // Inclui Favoritos no componente de Acesso Rápidp
                	                eventAggregator.publish('ZhFavoritesOnLoad', favorites);
                			    // }.bind(this));
        			    
            			    }
                           
                        }, function(error) {});
        			}
        		});
            }
        }, 1000);
    };
    
    function verificaAcessoFavoritos(dataset, favorites){
        var deferred = ZHPromise.defer();
        
        // Variavel de Posição no Array
        var pos = null;
        
        // Captura ID's dos Menus Favoritos
        var menuFavoritesIds = favorites.map(function(a) {return a.id;});
        
        // Regra Padrão
	    var defaultRule = dataset.zhu_access_control_default_rule.defaultRule;
        
        // Preenche Regra Padrão para todos os Favoritos
        favorites.forEach(function(favorite){
	        // Teste de Inativação
	        //favorite.rule = 'I';
	        
	        favorite.rule = defaultRule;
	    });
        
        // Percorre o Controle de Acesso dos Menus
        dataset.zhu_access_control_rule_login.forEach(function(acl){
            // Identifica existência de Controle de Acesso para o Menu
	        if(menuFavoritesIds.includes(acl.UNIQUE_ID)){
	            pos = menuFavoritesIds.indexOf(acl.UNIQUE_ID);
	            // Preenche Regra para o Menu
	            favorites[pos].rule = acl.RULE;
	        }
	    });
	    
	    // Permanece somente com os Favoritos ATIVOS(A)
	    favorites = favorites.filter(function(favorite) {
	        return ((favorite.rule == 'A') || (favorite.rule == 'R'));
	    });
        
        deferred.resolve(favorites);
        
        return deferred.promise;
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register("engine", engine);
});